<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/analytics/admin/v1alpha/expanded_data_set.proto

namespace Google\Analytics\Admin\V1alpha;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * A resource message representing a GA4 ExpandedDataSet.
 *
 * Generated from protobuf message <code>google.analytics.admin.v1alpha.ExpandedDataSet</code>
 */
class ExpandedDataSet extends \Google\Protobuf\Internal\Message
{
    /**
     * Output only. The resource name for this ExpandedDataSet resource.
     * Format: properties/{property_id}/expandedDataSets/{expanded_data_set}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $name = '';
    /**
     * Required. The display name of the ExpandedDataSet.
     * Max 200 chars.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $display_name = '';
    /**
     * Optional. The description of the ExpandedDataSet.
     * Max 50 chars.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $description = '';
    /**
     * Immutable. The list of dimensions included in the ExpandedDataSet.
     * See the [API
     * Dimensions](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#dimensions)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string dimension_names = 4 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $dimension_names;
    /**
     * Immutable. The list of metrics included in the ExpandedDataSet.
     * See the [API
     * Metrics](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#metrics)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string metric_names = 5 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $metric_names;
    /**
     * Immutable. A logical expression of ExpandedDataSet filters applied to
     * dimension included in the ExpandedDataSet. This filter is used to reduce
     * the number of rows and thus the change of encountering `other row`.
     *
     * Generated from protobuf field <code>.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression dimension_filter_expression = 6 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $dimension_filter_expression = null;
    /**
     * Output only. Time when expanded data set began (or will begin) collecing
     * data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp data_collection_start_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $data_collection_start_time = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Output only. The resource name for this ExpandedDataSet resource.
     *           Format: properties/{property_id}/expandedDataSets/{expanded_data_set}
     *     @type string $display_name
     *           Required. The display name of the ExpandedDataSet.
     *           Max 200 chars.
     *     @type string $description
     *           Optional. The description of the ExpandedDataSet.
     *           Max 50 chars.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $dimension_names
     *           Immutable. The list of dimensions included in the ExpandedDataSet.
     *           See the [API
     *           Dimensions](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#dimensions)
     *           for the list of dimension names.
     *     @type array<string>|\Google\Protobuf\Internal\RepeatedField $metric_names
     *           Immutable. The list of metrics included in the ExpandedDataSet.
     *           See the [API
     *           Metrics](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#metrics)
     *           for the list of dimension names.
     *     @type \Google\Analytics\Admin\V1alpha\ExpandedDataSetFilterExpression $dimension_filter_expression
     *           Immutable. A logical expression of ExpandedDataSet filters applied to
     *           dimension included in the ExpandedDataSet. This filter is used to reduce
     *           the number of rows and thus the change of encountering `other row`.
     *     @type \Google\Protobuf\Timestamp $data_collection_start_time
     *           Output only. Time when expanded data set began (or will begin) collecing
     *           data.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Analytics\Admin\V1Alpha\ExpandedDataSet::initOnce();
        parent::__construct($data);
    }

    /**
     * Output only. The resource name for this ExpandedDataSet resource.
     * Format: properties/{property_id}/expandedDataSets/{expanded_data_set}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Output only. The resource name for this ExpandedDataSet resource.
     * Format: properties/{property_id}/expandedDataSets/{expanded_data_set}
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. The display name of the ExpandedDataSet.
     * Max 200 chars.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Required. The display name of the ExpandedDataSet.
     * Max 200 chars.
     *
     * Generated from protobuf field <code>string display_name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * Optional. The description of the ExpandedDataSet.
     * Max 50 chars.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Optional. The description of the ExpandedDataSet.
     * Max 50 chars.
     *
     * Generated from protobuf field <code>string description = 3 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Immutable. The list of dimensions included in the ExpandedDataSet.
     * See the [API
     * Dimensions](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#dimensions)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string dimension_names = 4 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getDimensionNames()
    {
        return $this->dimension_names;
    }

    /**
     * Immutable. The list of dimensions included in the ExpandedDataSet.
     * See the [API
     * Dimensions](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#dimensions)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string dimension_names = 4 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setDimensionNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->dimension_names = $arr;

        return $this;
    }

    /**
     * Immutable. The list of metrics included in the ExpandedDataSet.
     * See the [API
     * Metrics](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#metrics)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string metric_names = 5 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getMetricNames()
    {
        return $this->metric_names;
    }

    /**
     * Immutable. The list of metrics included in the ExpandedDataSet.
     * See the [API
     * Metrics](https://developers.google.com/analytics/devguides/reporting/data/v1/api-schema#metrics)
     * for the list of dimension names.
     *
     * Generated from protobuf field <code>repeated string metric_names = 5 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param array<string>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setMetricNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->metric_names = $arr;

        return $this;
    }

    /**
     * Immutable. A logical expression of ExpandedDataSet filters applied to
     * dimension included in the ExpandedDataSet. This filter is used to reduce
     * the number of rows and thus the change of encountering `other row`.
     *
     * Generated from protobuf field <code>.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression dimension_filter_expression = 6 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return \Google\Analytics\Admin\V1alpha\ExpandedDataSetFilterExpression|null
     */
    public function getDimensionFilterExpression()
    {
        return $this->dimension_filter_expression;
    }

    public function hasDimensionFilterExpression()
    {
        return isset($this->dimension_filter_expression);
    }

    public function clearDimensionFilterExpression()
    {
        unset($this->dimension_filter_expression);
    }

    /**
     * Immutable. A logical expression of ExpandedDataSet filters applied to
     * dimension included in the ExpandedDataSet. This filter is used to reduce
     * the number of rows and thus the change of encountering `other row`.
     *
     * Generated from protobuf field <code>.google.analytics.admin.v1alpha.ExpandedDataSetFilterExpression dimension_filter_expression = 6 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param \Google\Analytics\Admin\V1alpha\ExpandedDataSetFilterExpression $var
     * @return $this
     */
    public function setDimensionFilterExpression($var)
    {
        GPBUtil::checkMessage($var, \Google\Analytics\Admin\V1alpha\ExpandedDataSetFilterExpression::class);
        $this->dimension_filter_expression = $var;

        return $this;
    }

    /**
     * Output only. Time when expanded data set began (or will begin) collecing
     * data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp data_collection_start_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getDataCollectionStartTime()
    {
        return $this->data_collection_start_time;
    }

    public function hasDataCollectionStartTime()
    {
        return isset($this->data_collection_start_time);
    }

    public function clearDataCollectionStartTime()
    {
        unset($this->data_collection_start_time);
    }

    /**
     * Output only. Time when expanded data set began (or will begin) collecing
     * data.
     *
     * Generated from protobuf field <code>.google.protobuf.Timestamp data_collection_start_time = 7 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setDataCollectionStartTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->data_collection_start_time = $var;

        return $this;
    }

}

